routes/web.php
<?php
date_default_timezone_set('Asia/Jakarta');
/* Route For Main View */
Route::get('/', function () {
    return redirect('/login');
});

/* Route For Auth */
Auth::routes();

/* Route For Main Menu */
Route::group(
    [
        'prefix' => 'admin',
        'middleware' => ['auth', 'role:admin|member'],
    ],
    function () {
        //Route Home
        Route::get('/home', 'admin\HomeController@index');
        
        //Route Change Password
        Route::get('change_password', [
            'as' => 'change_password',
            'uses' => 'Admin\UsersController@changePassword',
        ]);
        Route::post('store_password', [
            'as' => 'store_password',
            'uses' => 'Admin\UsersController@storeNewPassword',
        ]);

    }
);

Route::group(
    [
        'prefix' => 'admin',
        'middleware' => ['auth', 'role:admin'],
    ],
    function () {
        //Route Resource        
        Route::resource('master/users', 'Admin\UsersController');
        Route::resource('master/lapangan', 'Admin\LapanganController');
        Route::resource('master/harga', 'Admin\HargaController');

        //Route Booking
        Route::get('transaksi/booking/create/{date}', [
            'as' => 'booking.create',
            'uses' => 'Admin\BookingController@create',
        ]);

        Route::post('transaksi/booking/form_booking', [
            'as' => 'booking.form_booking',
            'uses' => 'Admin\BookingController@formBooking',
        ]);

        Route::post('transaksi/booking_list/form_booking_edit', [
            'as' => 'booking.form_booking_edit',
            'uses' => 'Admin\BookingController@formBookingEdit',
        ]);

        Route::post('transaksi/booking/store', [
            'as' => 'booking.store',
            'uses' => 'Admin\BookingController@store',
        ]);

        Route::put('transaksi/booking_list/update/{booking_id}', [
            'as' => 'booking.update',
            'uses' => 'Admin\BookingController@update',
        ]);

        Route::get('transaksi/booking_list', [
            'as' => 'booking.index',
            'uses' => 'Admin\BookingController@index',
        ]);

        Route::get('transaksi/booking_list/{booking_id}/edit', [
            'as' => 'booking.edit',
            'uses' => 'Admin\BookingController@edit',
        ]);

        Route::delete('transaksi/booking/destroy/{booking_id}', [
            'as' => 'booking.destroy',
            'uses' => 'Admin\BookingController@destroy',
        ]);

        //Route Tagihan
        Route::get('transaksi/tagihan', [
            'as' => 'tagihan.index',
            'uses' => 'Admin\PembayaranController@index',
        ]);

        Route::get('transaksi/tagihan/{user_id}/detail', [
            'as' => 'tagihan.detail',
            'uses' => 'Admin\PembayaranController@detailTagihan',
        ]);

        Route::post('transaksi/store', [
            'as' => 'tagihan.store',
            'uses' => 'Admin\PembayaranController@store',
        ]);

        //Route Pembayaran
        Route::get('pembayaran/laporan/{tahun}', [
            'as' => 'pembayaran.laporan',
            'uses' => 'Admin\PembayaranController@laporanPembayaran',
        ]);

        Route::get('pembayaran/laporan/{user_id}/{tahun}/detail', [
            'as' => 'pembayaran.detail',
            'uses' => 'Admin\PembayaranController@detailPembayaran',
        ]);

        Route::post('pembayaran/koreksi', [
            'as' => 'pembayaran.koreksi',
            'uses' => 'Admin\PembayaranController@koreksi',
        ]);

        Route::get('pembayaran/chart/{tahun}', [
            'as' => 'pembayaran.chart',
            'uses' => 'Admin\PembayaranController@chart',
        ]);

        //Last Record Harga
        Route::get('last_record_harga/{lapangan_id}/{hari}', 'Admin\HargaController@lastRecord');

    }
);


Route::get('auth/verify/{token}', 'Auth\RegisterController@verify');
Route::get('auth/send-verification', 'Auth\RegisterController@sendVerification');

app/Harga.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Harga extends Model
{
    protected $fillable = [
        'lapangan_id', 'hari', 'waktu_awal', 'waktu_akhir', 'harga',
        'created_at', 'updated_at'
    ];

    public function lapangan()
    {
        return $this->belongsTo('App\Lapangan');
    }
}

app/Http/Controllers/Admin/HargaController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Harga;
use App\Http\Controllers\Controller;
use Datatables;
use Illuminate\Http\Request;
use Illuminate\Support\Str;
use Validator;

class HargaController extends Controller
{

    public function index(Request $request)
    {
        if ($request->ajax()) {
            $hargas = Harga::select(['id', 'lapangan_id', 'hari', 'waktu_awal', 'waktu_akhir', 'harga'])->get();
            return Datatables::of($hargas)
                ->addColumn('lapangan', function ($harga) {
                    return $harga->lapangan->nama;
                })
                ->addColumn('waktu_awal', function ($harga) {
                    return futsalTime($harga->waktu_awal);
                })
                ->addColumn('waktu_akhir', function ($harga) {
                    return futsalTime($harga->waktu_akhir);
                })
                ->addColumn('harga', function ($harga) {
                    return torp($harga->harga);
                })
                ->addColumn('action', function ($harga) {
                    return view('admin.datatables._action', [
                        'id' => $harga->id,
                        'destroy_url' => route('harga.destroy', $harga->id),
                        'edit_url' => route('harga.edit', $harga->id),
                        'confirm_message' => 'Apakah anda yakin ingin menghapus Harga ' . $harga->nama . ' ?',
                    ]);
                })
                ->rawColumns(['lapangan', 'waktu_awal', 'waktu_akhir', 'harga', 'action'])
                ->filter(function ($instance) use ($request) {
                    if (!empty($request->get('lapangan'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['lapangan'], $request->get('lapangan')) ? true : false;
                        });
                    }
                    if (!empty($request->get('hari'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['hari'], $request->get('hari')) ? true : false;
                        });
                    }
                    if (!empty($request->get('waktu_awal'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['waktu_awal'], $request->get('waktu_awal')) ? true : false;
                        });
                    }
                    if (!empty($request->get('waktu_akhir'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['waktu_akhir'], $request->get('waktu_akhir')) ? true : false;
                        });
                    }
                    if (!empty($request->get('harga'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['harga'], $request->get('harga')) ? true : false;
                        });
                    }
                })
                ->make(true);
        }

        $data['title'] = 'Daftar Harga';
        return view('admin.harga.index', $data);
    }

    public function create()
    {
        $data['title'] = 'Tambah Harga';
        $data['hari'] = hari();
        return view('admin.harga.create', $data);
    }

    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'lapangan_id' => 'required',
            'hari' => 'required',
            'harga' => 'required',
        ]);

        if ($validator->passes()) {

            $batas_bawah = Harga::where([
                ['lapangan_id', $request->lapangan_id],
                ['hari', $request->hari]
            ])->latest('waktu_akhir');

            if($batas_bawah->count() > 0){
                $waktu_akhir = $batas_bawah->first()->waktu_akhir;
            }else{
                $waktu_akhir = 0;
            }

            if ($request->waktu_awal > $waktu_akhir && $request->waktu_akhir > $request->waktu_awal) {
                $harga = Harga::create($request->all());
                return response()->json(['success' => 'Berhasil menambahkan Lapangan']);
            } else {
                $error = [
                    'waktu_awal' => ['Silakan cek kembali pengaturan waktu, waktu awal harus lebih besar dari waktu akhir terakhir'],
                    'waktu_akhir' => ['Silakan cek kembali pengaturan waktu, waktu awal harus lebih besar dari waktu awal'],
                ];
                return response()->json(['error' => $error]);
            }

        } else {
            return response()->json(['error' => $validator->getMessageBag()->toArray()]);
        }
    }

    public function lastRecord($lapangan_id, $hari)
    {
        $data['last_record'] = Harga::where([
            ['lapangan_id', $lapangan_id],
            ['hari', $hari],
        ])->get();

        return view('admin.harga._lastrecord', $data);
    }

    public function edit($id)
    {
        $data['title'] = 'Edit Harga';
        $data['hari'] = hari();
        $data['harga'] = Harga::find($id);
        return view('admin.harga.edit', $data);
    }

    public function update(Request $request, $id)
    {
        $validator = Validator::make($request->all(), [
            'lapangan_id' => 'required',
            'hari' => 'required',
            'harga' => 'required',
        ]);

        if ($validator->passes()) {

            $harga = Harga::find($id);

            $waktu_awal = $harga->waktu_awal;

            $batas_bawah = Harga::where([
                ['lapangan_id', $request->lapangan_id],
                ['hari', $request->hari],
                ['id', '!=', $id],
                ['waktu_akhir', '<', $request->waktu_akhir],
            ])->max('waktu_akhir');

            $batas_atas = Harga::where([
                ['lapangan_id', $request->lapangan_id],
                ['hari', $request->hari],
                ['id', '!=', $id],
                ['waktu_akhir', '>', $request->waktu_akhir],
            ])->max('waktu_awal');

            if ($request->waktu_akhir > $request->waktu_awal) {

                if ($batas_bawah > 0 && $batas_atas > 0) {
                    if ($request->waktu_awal > $batas_bawah && $request->waktu_akhir < $batas_atas) {
                        $harga->update($request->all());
                        return response()->json(['success' => 'Berhasil mengubah data Harga']);
                    } else {
                        $error = [
                            'waktu_awal' => ["Batas bawah waktu awal adalah " . futsalTime($batas_bawah) . ", waktu awal harus lebih besar dari batas bawah"],
                            'waktu_akhir' => ["Batas atas waktu akhir adalah " . futsalTime($batas_atas) . ", waktu akhir harus lebih kecil dari batas atas"],
                        ];
                        return response()->json(['error' => $error]);
                    }
                } else if ($batas_bawah > 0 && $batas_atas == 0) {
                    if ($request->waktu_awal > $batas_bawah) {
                        $harga->update($request->all());
                        return response()->json(['success' => 'Berhasil mengubah data Harga']);
                    } else {
                        $error = [
                            'waktu_awal' => ["Batas bawah waktu awal adalah " . futsalTime($batas_bawah) . ", waktu awal harus lebih besar dari batas bawah"],
                        ];
                        return response()->json(['error' => $error]);
                    }
                } else if ($batas_bawah == 0 && $batas_atas > 0) {
                    if ($request->waktu_akhir < $batas_atas) {
                        $harga->update($request->all());
                        return response()->json(['success' => 'Berhasil mengubah data Harga']);
                    } else {
                        $error = [
                            'waktu_akhir' => ["Batas atas waktu akhir adalah " . futsalTime($batas_atas) . ", waktu akhir harus lebih kecil dari batas atas"],
                        ];
                        return response()->json(['error' => $error]);
                    }
                }else{
                    $harga->update($request->all());
                    return response()->json(['success' => 'Berhasil mengubah data Harga']);
                }

            } else {
                $error = [
                    'waktu_awal' => ['Silakan cek kembali pengaturan waktu, waktu awal harus lebih besar dari waktu akhir terakhir'],
                    'waktu_akhir' => ['Silakan cek kembali pengaturan waktu, harus lebih besar dari waktu awal'],
                ];
                return response()->json(['error' => $error]);
            }

        } else {
            return response()->json(['error' => $validator->getMessageBag()->toArray()]);
        }
    }

    public function destroy($id)
    {
        $harga = Harga::where('id', $id)->delete();
        return response()->json(['id' => $id]);
    }

}

resources/views/admin/harga/_form.blade.php
<div class="form-group group-lapangan_id">
    {!! Form::label('lapangan_id', 'Lapangan', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        <div class="input-group">
            <span class="input-group-addon">
                <span class="fa fa-flag"></span>
            </span>
            {!! Form::select('lapangan_id', ['' => '- Pilih Lapangan -']+App\Lapangan::pluck('nama', 'id')->all(), 
            null, ['class' => 'form-control', 'id' => 'lapangan_id', 'onchange' => 'last_record()']) !!}
        </div>
    </div>
</div>

<div class="form-group group-hari">
    {!! Form::label('nama', 'Hari', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        <div class="input-group">
            <span class="input-group-addon">
                <span class="fa fa-clock-o"></span>
            </span>
            {!! Form::select('hari', $hari, null, ['class' => 'form-control', 'id' => 'hari', 'onchange' => 'last_record()']) !!}
        </div>
    </div>
</div>

<div class="form-group group-waktu_awal">
    {!! Form::label('waktu_awal', 'Waktu Awal', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        <div class="input-group">
            <span class="input-group-addon">
                <span class="fa fa-clock-o"></span>
            </span>
            {!! Form::select('waktu_awal', waktu(), null, ['class' => 'form-control']) !!}
        </div>
    </div>
</div>

<div class="form-group group-waktu_akhir">
    {!! Form::label('waktu_akhir', 'Waktu Akhir', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        <div class="input-group">
            <span class="input-group-addon">
                <span class="fa fa-clock-o"></span>
            </span>
            {!! Form::select('waktu_akhir', waktu(), null, ['class' => 'form-control']) !!}
        </div>
    </div>
</div>

<div class="form-group group-harga">
    {!! Form::label('harga', 'Harga', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        <div class="input-group">
            <span class="input-group-addon">
                <span class="fa fa-money"></span>
            </span>
            {!! Form::number('harga', null, ['class' => 'form-control']) !!}
        </div>
    </div>
</div>

@section('scripts')
    <script>
        $(document).ready(function(){
            last_record();
        });

        function last_record(){
            let lapangan_id = $("#lapangan_id").val();
            let hari = $("#hari").val();

            if(lapangan_id != '' && hari != ''){
                loadView("{{ url('admin/last_record_harga') }}/"+lapangan_id+"/"+hari, '#last-record');
            }
        }
    </script>
@endsection

resources/views/admin/harga/_lastrecord.blade.php
@if ($last_record->count() > 0)
@foreach ($last_record as $harga)
    <tr>
        <td>{{ $harga->hari }}</td>
        <td>{{ futsalTime($harga->waktu_awal) }}</td>
        <td>{{ futsalTime($harga->waktu_akhir) }}</td>
        <td>{{ torp($harga->harga) }}</td>
    </tr>

@endforeach
@else
    <tr>
        <td>-</td>
        <td>-</td>
        <td>-</td>
        <td>-</td>
    </tr>
@endif

resources/views/admin/harga/create.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li>Master Data</li>
    <li>Harga</li>
    <li class="active">Tambah Data</li>
</ul>


<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Form Harga</h3>
                </div>

                {!! Form::open(['url' => route('harga.store'),
                    'class' => 'form-horizontal form-save',
                    'method' =>'post',
                    'data-btn' => 'btn-save',
                    'data-rule' => 'save-harga']) !!}
                    
                <div class="panel-body">
                    <a class="btn btn-default waves-effect" href="{{ route('harga.index') }}">
                        <i class="fa fa-arrow-left"> Kembali</i>
                    </a>
                    <hr>
                    <div class="row">
                        <div class="col-md-6">
                            @include('admin.harga._form')
                        </div>
                        <div class="col-md-6">
                            <div>
                                <div class="panel panel-default">
                                   <table class="table table-bordered table-hover">
                                       <thead>
                                           <th>Hari</th>
                                           <th>Waktu Awal</th>
                                           <th>Waktu Akhir</th>
                                           <th>Harga</th>
                                       </thead>
                                       <tbody id="last-record">
                                           <tr>
                                              <td>-</td>
                                              <td>-</td>
                                              <td>-</td>
                                              <td>-</td>
                                           </tr>
                                       </tbody>
                                   </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="panel-footer">
                    {!! Form::submit('Simpan', ['class'=>'btn btn-primary pull-right', 'id' => 'btn-save']) !!}
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admin/harga/edit.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li>Master Data</li>
    <li>Harga</li>
    <li class="active">Edit</li>
</ul>

<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Form Harga</h3>
                </div>

                {!! Form::model($harga, ['url' => route('harga.update', $harga->id),
                    'class' => 'form-horizontal form-save',
                    'method' =>'put',
                    'data-btn' => 'btn-save',
                    'data-redirect' => route('harga.index')]) !!}

                <div class="panel-body">
                    <a class="btn btn-default waves-effect" href="{{ route('harga.index') }}">
                        <i class="fa fa-arrow-left"> Kembali</i>
                    </a>
                    <hr>
                    <div class="row">
                        <div class="col-md-6">
                            @include('admin.harga._form')
                        </div>
                        <div class="col-md-6">
                            <div>
                                <div class="panel panel-default">
                                    <table class="table table-bordered table-hover">
                                        <thead>
                                            <th>Hari</th>
                                            <th>Waktu Awal</th>
                                            <th>Waktu Akhir</th>
                                            <th>Harga</th>
                                        </thead>
                                        <tbody id="last-record">
                                            <tr>
                                                <td>-</td>
                                                <td>-</td>
                                                <td>-</td>
                                                <td>-</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="panel-footer">
                    {!! Form::submit('Simpan', ['class'=>'btn btn-primary pull-right', 'id' => 'btn-save']) !!}
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admin/harga/index.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li>Master Data</li>
    <li class="active">Harga</li>
</ul>

<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Daftar Harga</h3>
                </div>
                <div class="panel-body">
                    <div class="row">
                        <a class="btn btn-default waves-effect" href="{{ route('harga.create') }}">Tambah Harga</a>
                        <hr>
                        <div class="col-md-12">
                            <table id="hargas" class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th width="10%">ID</th>
                                        <th>Lapangan</th>
                                        <th>Hari</th>
                                        <th>Waktu Awal</th>
                                        <th>Waktu Akhir</th>
                                        <th>Harga</th>
                                        <th width="10%">Action</th>
                                    </tr>
                                </thead>
                                <tfoot>
                                    <tr>
                                        <td></td>
                                        <td>
                                            {!! Form::text('lapangan', null, ['class' => 'form-control', 'placeholder' => 'Lapangan', 'id' => 'lapangan']) !!}
                                        </td>
                                        <td>
                                            {!! Form::text('hari', null, ['class' => 'form-control', 'placeholder' => 'Hari', 'id' => 'hari']) !!}
                                        </td>
                                        <td>
                                            {!! Form::text('waktu_awal', null, ['class' => 'form-control', 'placeholder' => 'Waktu Awal', 'id' => 'waktu_awal']) !!}
                                        </td>
                                        <td>
                                            {!! Form::text('waktu_akhir', null, ['class' => 'form-control', 'placeholder' => 'Waktu Akhir', 'id' => 'waktu_akhir']) !!}
                                        </td>
                                        <td>
                                            {!! Form::text('harga', null, ['class' => 'form-control', 'placeholder' => 'Harga', 'id' => 'harga']) !!}
                                        </td>
                                        <td></td>
                                    </tr>
                                </tfoot>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('scripts')
<script type="text/javascript">
    $(function () {
        var table = $('#hargas').DataTable({
            processing: false,
            serverSide: true,
            order: [ [0, 'desc'] ],
            ajax: {
                url: "{{ route('harga.index') }}",
                data: function (d) {
                    d.lapangan = $('#lapangan').val(),
                    d.hari = $('#hari').val(),
                    d.waktu_awal = $('#waktu_awal').val(),
                    d.waktu_akhir = $('#waktu_akhir').val(),
                    d.harga = $('#harga').val()
                }
            },
            columns: [{
                    data: 'id',
                    name: 'id'
                },
                {
                    data: 'lapangan',
                    name: 'lapangan'
                },
                {
                    data: 'hari',
                    name: 'hari'
                },
                {
                    data: 'waktu_awal',
                    name: 'waktu_awal'
                },
                {
                    data: 'waktu_akhir',
                    name: 'waktu_akhir'
                },
                {
                    data: 'harga',
                    name: 'harga'
                },
                {
                    data: 'action',
                    name: 'action',
                    orderable: false,
                    searchable: false
                }
            ]
        });

        $('#lapangan').on('change', function () {
            table.draw();
        });
        $('#hari').on('change', function () {
            table.draw();
        });
        $('#waktu_awal').on('change', function () {
            table.draw();
        });
        $('#waktu_akhir').on('change', function () {
            table.draw();
        });
        $('#harga').on('change', function () {
            table.draw();
        });
    });
</script>
@endsection

@section('style')
<style>
    #hargas_filter {
        display: none;
    }
    #hargas_length {
        width: 100%;
    }
</style>
@endsection